#!/usr/bin/env python
import sys #For using argument
import glob
from Bio import SeqIO


def parse_fasta(infile):
	AllSeq = SeqIO.parse(infile, 'fasta')
	return [i for i in AllSeq]
	
out = open('identity.txt', 'w')
genome_list = ['Athaliana', 'Alyrata', 'Cgrandiflora', 'Crubella', 'Bstricta', 'Brapa', 'Esalsugineum', 'Cpapaya', 'Csinensis', 'Ptrichocarpa', 'Mtruncatula', 'Slycopersicum', 'Osativa', 'Sitalica', 'Atrichopoda', 'Smoellendorffii']

alignment_list = glob.glob('*.translated.fasta')
identity_dict = {}
locus_list = []
for alignment_file in alignment_list:
	alignment = parse_fasta(alignment_file)
	locus = alignment_file.split('_')[0]
	locus_list.append(locus)

	for seq in alignment:
		genome_origin = str(seq.id).split('_')[0]
		if genome_origin.startswith('AT'):
			AT_seq = str(seq.seq)
			continue
		else:
			target_seq = str(seq.seq)
			match = 0
			length = 0
			for i, j in zip(AT_seq, target_seq):
				if i == '-' and j == '-':
					pass
				elif i == 'X' or j == 'X':
					pass
				else:
					if i == j:
						match = match + 1
					length = length + 1
			percent_match = match / float(length)
			key = genome_origin + '-' + locus
			try:
				if identity_dict[key] < percent_match:
					identity_dict[key] = percent_match
			except:
				identity_dict[key] = percent_match


out.write('\t' + '\t'.join(locus_list) + '\n')
for genome_origin in genome_list:
	if genome_origin != 'Athaliana':
		out.write(genome_origin + '\t')
		for locus in locus_list:
			key = genome_origin + '-' + locus
			try:
				out.write(str(identity_dict[key]) + '\t')
			except:
				out.write('NA' + '\t')
		out.write('\n')




	